# -*- coding: utf-8 -*-
#
# File: guestbookentry.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.testguestbook.config import *

##code-section module-header #fill in your manual code here
from Products.CMFCore.utils import *
##/code-section module-header

schema = Schema((

    StringField(
        name='name',
        widget=StringWidget(
            label="Name",
            description="Please enter your name",
            label_msgid='testguestbook_label_name',
            description_msgid='testguestbook_help_name',
            i18n_domain='testguestbook',
        ),
        required=True,
        searchable=True
    ),

    StringField(
        name='email',
        widget=StringWidget(
            label="Email",
            description="Please enter your email address",
            label_msgid='testguestbook_label_email',
            description_msgid='testguestbook_help_email',
            i18n_domain='testguestbook',
        ),
        required=False,
        searchable=False
    ),

    StringField(
        name='url',
        widget=StringWidget(
            label="Homepage",
            description="Please enter your Homepage",
            label_msgid='testguestbook_label_url',
            description_msgid='testguestbook_help_url',
            i18n_domain='testguestbook',
        ),
        required=False,
        searchable=True
    ),

    TextField(
        name='comment',
        allowable_content_types=('text/plain', 'text/structured', 'text/html', 'application/msword',),
        widget=RichWidget(
            label="Comment",
            description="Please enter your comments",
            label_msgid='testguestbook_label_comment',
            description_msgid='testguestbook_help_comment',
            i18n_domain='testguestbook',
        ),
        default_output_type='text/html',
        searchable=True,
        required=True
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

guestbookentry_schema = BaseSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class guestbookentry(BaseContent):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseContent,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'guestbookentry'

    meta_type = 'guestbookentry'
    portal_type = 'guestbookentry'
    allowed_content_types = []
    filter_content_types = 0
    global_allow = 0
    #content_icon = 'guestbookentry.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "An entry in the plone guestbook"
    typeDescMsgId = 'description_edit_guestbookentry'


    actions =  (


       {'action': "string:${object_url}/guestbookentry_view",
        'category': "object",
        'id': 'guestbookentry_view',
        'name': 'guestbookentry_view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/getName",
        'category': "object",
        'id': 'getName',
        'name': 'getName',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/getComment",
        'category': "object",
        'id': 'getComment',
        'name': 'getComment',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/getUrl",
        'category': "object",
        'id': 'getUrl',
        'name': 'getUrl',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/getEmail",
        'category': "object",
        'id': 'getEmail',
        'name': 'getEmail',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/getState",
        'category': "object",
        'id': 'getState',
        'name': 'getState',
        'permissions': ("View",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = guestbookentry_schema

    ##code-section class-header #fill in your manual code here
    def getEmail(self):
        value = self.email
        if value == "":
            return "n/a"
        else:
            return value

    def getUrl(self):
        value = self.url
        if value == "":
            return "n/a"
        elif value.startswith("http://") or value.startswith("https://"):
            return value
        else:
            return "http://" + value

    def getState(self):
        """ gets the current workflow state """
	workflowtool = getToolByName (self, "portal_workflow")
	return workflowtool.getInfoFor(self, "review_state")
    ##/code-section class-header

    # Methods


registerType(guestbookentry, PROJECTNAME)
# end of class guestbookentry

##code-section module-footer #fill in your manual code here
##/code-section module-footer



