# -*- coding: utf-8 -*-
#
# File: guestbookfolder.py
#
# Copyright (c) 2006 by []
# Generator: ArchGenXML Version 1.5.0
#            http://plone.org/products/archgenxml
#
# GNU General Public License (GPL)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#

__author__ = """unknown <unknown>"""
__docformat__ = 'plaintext'

from AccessControl import ClassSecurityInfo
from Products.Archetypes.atapi import *
from Products.testguestbook.config import *

##code-section module-header #fill in your manual code here
import sys, logging
##/code-section module-header

schema = Schema((

    StringField(
        name='name',
        widget=StringWidget(
            label="Name",
            description="The name of the guestbook",
            label_msgid='testguestbook_label_name',
            description_msgid='testguestbook_help_name',
            i18n_domain='testguestbook',
        ),
        required=True,
        searchable=True
    ),

    TextField(
        name='description',
        allowable_content_types=('text/plain', 'text/structured', 'text/html', 'application/msword',),
        widget=RichWidget(
            label="Description",
            description="Please enter some description for the guestbook",
            label_msgid='testguestbook_label_description',
            description_msgid='testguestbook_help_description',
            i18n_domain='testguestbook',
        ),
        default_output_type='text/html',
        searchable=True,
        required=True
    ),

),
)

##code-section after-local-schema #fill in your manual code here
##/code-section after-local-schema

guestbookfolder_schema = BaseFolderSchema.copy() + \
    schema.copy()

##code-section after-schema #fill in your manual code here
##/code-section after-schema

class guestbookfolder(BaseFolder):
    """
    """
    security = ClassSecurityInfo()
    __implements__ = (getattr(BaseFolder,'__implements__',()),)

    # This name appears in the 'add' box
    archetype_name = 'guestbookfolder'

    meta_type = 'guestbookfolder'
    portal_type = 'guestbookfolder'
    allowed_content_types = ['guestbookentry']
    filter_content_types = 1
    global_allow = 1
    #content_icon = 'guestbookfolder.gif'
    immediate_view = 'base_view'
    default_view = 'base_view'
    suppl_views = ()
    typeDescription = "The Plone Guestbook Folder"
    typeDescMsgId = 'description_edit_guestbookfolder'


    actions =  (


       {'action': "string:${object_url}/guestbookfolder_view",
        'category': "object",
        'id': 'guestbookfolder_view',
        'name': 'guestbookfolder_view',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/getEntries",
        'category': "object",
        'id': 'getEntries',
        'name': 'getEntries',
        'permissions': ("View",),
        'condition': 'python:1'
       },


       {'action': "string:${object_url}/getDescription",
        'category': "object",
        'id': 'getDescription',
        'name': 'getDescription',
        'permissions': ("View",),
        'condition': 'python:1'
       },


    )

    _at_rename_after_creation = True

    schema = guestbookfolder_schema

    ##code-section class-header #fill in your manual code here
    def getEntries(self):
        logger = logging.getLogger('CMFCore.MembershipTool')
        list = []
        for object in self.listFolderContents():
            if(object.meta_type=='guestbookentry'):
                if (object.getState().lower() == "approved"):
                    list.append(object)
            else:
                logger.error("unknown metatype: %s" % object.meta_type)
        return list

    ##/code-section class-header

    # Methods


registerType(guestbookfolder, PROJECTNAME)
# end of class guestbookfolder

##code-section module-footer #fill in your manual code here
##/code-section module-footer



